<template>
  <div class="game">
    <SpaceshipComponent ref="spaceship" @shoot="handleShoot"/>
    <AsteroidComponent v-for="asteroid in asteroids" :key="asteroid.id" :asteroid="asteroid"/>
    <BulletComponent v-for="bullet in bullets" :key="bullet.id" :bullet="bullet"/>
  </div>
</template>
<script>
import SpaceshipComponent from './SpaceshipComponent.vue';
import AsteroidComponent from './AsteroidComponent.vue';
import BulletComponent from './BulletComponent.vue';

export default {
  components: {
    SpaceshipComponent,
    AsteroidComponent,
    BulletComponent
  },
  data() {
    return {
      asteroids: [],
      bullets: [],
      asteroidId: 0,
      bulletId: 0
    };
  },
  methods: {
    handleShoot(bullet) {
      bullet.id = this.bulletId++;
      this.bullets.push(bullet);
    },
    gameLoop() {
      this.moveAsteroids();
      this.moveBullets();
      this.checkCollisions();
      this.spawnAsteroids();
    },
    moveAsteroids() {
      this.asteroids.forEach(asteroid => {
        asteroid.y += 1;
      });
      this.asteroids = this.asteroids.filter(asteroid => asteroid.y < 100);
    },
    moveBullets() {
      this.bullets.forEach(bullet => {
        bullet.y -= 2;
      });
      this.bullets = this.bullets.filter(bullet => bullet.y > 0);
    },
    spawnAsteroids() {
      if (Math.random() < 0.02) {
        this.asteroids.push({
          id: this.asteroidId++,
          x: Math.random() * 100,
          y: 0
        });
      }
    },
    checkCollisions() {
      this.bullets.forEach(bullet => {
        this.asteroids.forEach((asteroid, asteroidIndex) => {
          if (this.isColliding(bullet, asteroid)) {
            this.bullets = this.bullets.filter(b => b !== bullet);
            this.asteroids.splice(asteroidIndex, 1);
          }
        });
      });
    },
    isColliding(bullet, asteroid) {
      return (
        bullet.x >= asteroid.x &&
        bullet.x <= asteroid.x + 5 &&
        bullet.y >= asteroid.y &&
        bullet.y <= asteroid.y + 5
      );
    }
  },
  mounted() {
    this.gameInterval = setInterval(this.gameLoop, 16); // 60 FPS
  },
  beforeUnmount() {
    clearInterval(this.gameInterval);
  }
};
</script>


<style scoped>
.game {
  position: relative;
  width: 100%;
  height: 100vh;
  overflow: hidden;
  background-color: black;
}
</style>
